﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CommandPatternTest
{
    class Program
    {
        static void Main(string[] args)
        {
            SimpleRemoteControl remoteControl = new SimpleRemoteControl();
            Light light = new Light();
            LightOnCommand lightOn = new LightOnCommand(light);
            remoteControl.SetCommand(lightOn);
            remoteControl.ButtonWasPressed();
            Console.ReadKey();
        }
    }

    public interface ICommand
    {
         void Execute();
    }

    public class Light
    {
        public void On()
        {
            Console.WriteLine("灯开了");
        }
        public void Off()
        {
            Console.WriteLine("灯关掉了");
        }
    }


    public class LightOnCommand : ICommand
    {
        Light light;
        public LightOnCommand(Light light)
        {
            this.light = light;
        }

        void ICommand.Execute()
        {
            light.On();
        }
    }


    public class SimpleRemoteControl
    {
        ICommand slot;
        public SimpleRemoteControl() { }

        public void SetCommand(ICommand command)
        {
            slot = command;
        }

        public void ButtonWasPressed()
        {
            slot.Execute();
        }
    }
}
